Package net.dona.doip.server

## Interface DoipServerRequest

- All Known Implementing Classes:
    `DoipServerRequestImpl`

      public interface DoipServerRequest

  Interface for an incoming DOIP request to be handled by a `DoipProcessor`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `com.google.gson.JsonElement` | `getAttribute​(java.lang.String key)` | Returns a single attribute from the attributes given by the initial segment of the request.
    `java.lang.String` | `getAttributeAsString​(java.lang.String key)` | Returns as a String a single attribute from the attributes given by the initial segment of the request.
    `com.google.gson.JsonObject` | `getAttributes()` | Returns the attributes given by the initial segment of the request.
    `com.google.gson.JsonElement` | `getAuthentication()` | Returns the authentication information given by the initial segment of the request.
    `java.lang.String` | `getClientId()` | Returns the client id given by the initial segment of the request.
    `java.security.cert.X509Certificate[]` | `getConnectionCertificateChain()` | If the client is using a TLS client-side certificate, this returns the supplied certificate chain.
    `java.lang.String` | `getConnectionClientId()` | If the client is using a TLS client-side certificate, this returns the client id from the certificate.
    `java.security.PublicKey` | `getConnectionPublicKey()` | If the client is using a TLS client-side certificate, this returns the public key from the certificate.
    `InDoipMessage` | `getInput()` | Returns the input of the request.
    `java.lang.String` | `getOperationId()` | Returns the operation id (the operation to perform) given by the initial segment of the request.
    `java.lang.String` | `getTargetId()` | Returns the target id (the object on which to perform the operation) given by the initial segment of the request.

- - ### Method Detail

    - #### getClientId

          java.lang.String getClientId()

      Returns the client id given by the initial segment of the request.

    - #### getTargetId

          java.lang.String getTargetId()

      Returns the target id (the object on which to perform the operation) given by the initial segment of the request.

    - #### getOperationId

          java.lang.String getOperationId()

      Returns the operation id (the operation to perform) given by the initial segment of the request.

    - #### getAttributes

          com.google.gson.JsonObject getAttributes()

      Returns the attributes given by the initial segment of the request.

    - #### getAttribute

          com.google.gson.JsonElement getAttribute​(java.lang.String key)

      Returns a single attribute from the attributes given by the initial segment of the request.
      Parameters:
        `key` - the attribute to retrieve

    - #### getAttributeAsString

          java.lang.String getAttributeAsString​(java.lang.String key)

      Returns as a String a single attribute from the attributes given by the initial segment of the request.
      Parameters:
        `key` - the attribute to retrieve

    - #### getAuthentication

          com.google.gson.JsonElement getAuthentication()

      Returns the authentication information given by the initial segment of the request.

    - #### getInput

          InDoipMessage getInput()

      Returns the input of the request. In the case of a "compact" single-segment request, this will be a single JSON segment corresponding to the "input" property of the single-segment request. Otherwise it will be all remaining segments of the request after the initial segment.

    - #### getConnectionClientId

          java.lang.String getConnectionClientId()

      If the client is using a TLS client-side certificate, this returns the client id from the certificate.

    - #### getConnectionPublicKey

          java.security.PublicKey getConnectionPublicKey()

      If the client is using a TLS client-side certificate, this returns the public key from the certificate.

    - #### getConnectionCertificateChain

          java.security.cert.X509Certificate[] getConnectionCertificateChain()

      If the client is using a TLS client-side certificate, this returns the supplied certificate chain.